MAPIT:    MOV R1,#DISPL                 ; SET R1 TO DISPL LOC.
          MOV A,@R1                     ; READ LOC DISPL FOR PRESENT REQ FOR DISPLAY.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#MAPCD                  ; ADD TO ACC ADDR MAPCD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV R0,A                      ; LOAD MAP LOCATION IN R0
          MOV R1,#DSPST-DVMNO           ; MOVE INTO R1 POL LOCATION OF DSPMP 63-4=59
          MOV A,@R0                     ; READ IF 1 NEG IF 0 POS.
          INC R0                        ; TO GO TO THOUSANDS PLACE.
          MOV R7,#DVMNO                 ; SET R7 TO 4 EXCLUDE POLARITY.
          JNZ GLITE                     ; IF ACC IS NOT ZERO JUMP TO GLITE.
          MOV @R1,#BLANK XOR SKORA      ; IF ACCC IS 0 BLANK DIGIT TO SHOW POSITIVE.
          MOV R1,#TPLMT                 ; SET R1 TO MAX LT LOC.
          JMP GNLIT                     ; JMP OVER.
GLITE:    MOV @R1,#40H XOR SKORA        ; 40H IS 0100 0000 WHICH LIGHTS UP SEG G. MINUS SIGN
          MOV R1,#BTLMT                 ; SET R1 TO MIN LT LOC.
GNLIT:    MOV A,@R1                     ; READ MAX  / MIN LT
          DEC A                         ; DEC SETTING IF 1 1-1=0 0-0=C N SET 0-1 C SET OVRFLO
          CPL A                         ; COMPLIMENT ACC.
          MOV R1,#DSPST-DVMNO+1         ; MOVE INTO R1 K LOCATION OF DSPMP 63-4+1=60
          ADD A,@R0                     ; SUBSTRACT K VALUE IN MAP.
          JC OVRRN                      ; IF CARRY IS SET OVERRANGE.
          JMP UPDAT                     ; CARRY NOT SET INRANGE.
OVRRN:    DEC R0                        ; GO BACK TO POL POS OF MAP.
          MOV A,@R0                     ; READ POL.
          JNZ LOWRT                     ; IF NEG POL TAKE LOW ROUTE
          MOV R2,#HILCD                 ; IF +SET R2 HILCD
          JMP HIGRT                     ; DISPLAY HILT.
LOWRT:    MOV R2,#LOLCD                 ; DISPLAY LOLT.
HIGRT:    CLR C                         ; CLEAR CARRY.
OVRRL:    MOV A,R2                      ; MOV TO ACC ADDR HILCD/LOLCD
          MOVP3 A,@A                    ; FETCH CODE FROM TABLE ADDR BY ACC
          MOV @R1,A                     ; PUT DISPLAY AS IN HILCD Hi.Lt.
          INC R2                        ; INC R2 +1,+2... GET CONSECUT CODES IN TABLE HILCD.
          INC R1                        ; INC R1 K,H,T,U,.
          DJNZ R7,OVRRL                 ; LOOP TILL K,H,T,U PLACE HAS Hi.Lt.
          JMP MTRET                     ; IN OVRRANGE DP NOT REQ.
UPDAT:    MOV A,@R0                     ; READ LOC 80-3 TO ACC, IT WILL INC FOR EVERY DNJZ.
          CALL ENSGM                    ; ENCODE ACC VALUE LOWER NIBBLE TO 7SEG VALUE.
          MOV @R1,A                     ; WRITE TO INTERNAL RAM AT 58 DECODED 7 SEG VALUE.
          INC R1                        ; SELECT NEXT INT RAM LOC 59.....SO ON.
          INC R0                        ; SELECT NEXT INT RAM LOC 76.....SO ON.
          DJNZ R7,UPDAT                 ; LOOP TO CLEAN TILL DGNXT IS 0. TILL 58,TO 62 UPDAT.
MAPDP:    MOV R1,#DPSET                 ; SET R1 TO LOC DPSET WHICH WILL BE INC-DEC BY DNSET
          MOV A,@R1                     ; READ DPSET VALUE 5 TO 10.
          ADD A,#DSPMP                  ; GET DSPMP ADDR NUMBER 63-9=54 RAM .
          MOV R1,A                      ; SET R1 TO DSPMP FOR WHICH DP IS TO BE SET.
          MOV A,@R1                     ; READ TO ACC SEGCODE IN MAP.
          XRL A,#SKORA                  ; RESTORE CODE TO LOGIC.
          ORL A,#10000000B              ; SET DP LIGHTING BIT ON.
          XRL A,#SKORA                  ; REMAKE CODE TO MAP.
          MOV @R1,A                     ; REWRITE IN SAME LOCATION.
MTRET:    RET                           ; RETURN.
                                        ;
DCSET:    MOV R0,#KEYPR                 ; ASSIGN R0 TO KEYPR.
          MOV A,@R0                     ; READ KEYPR.
          JB4 DCINC                     ; JUMP TO DCINC IF ACC BIT 4 IS SET.
          JB6 DCDEC                     ; JUMP TO DCDEC IF ACC BIT 6 IS SET.
          JMP DCRET                     ; KEY SERVED.
DCINC:    MOV A,@R1                     ; READ TPLMT / BTLMT VALUE.
          XRL A,#9                      ; COMPARE WITH MAX COUNT OF 9
          JZ DCRET                      ; IF ZERO DONT INC.
          INC @R1                       ; IF NOT THEN INCREMENT TPLMT / BTLMT
          JMP DCRET                     ; RETURN.
DCDEC:    MOV A,@R1                     ; READ TPLMT / BTLMT VALUE.
          XRL A,#1                      ; COMPARE WITH MIN COUNT OF 1
          JZ DCRET                      ; IF ZERO TPLMT / BTLMT WAS AT 0  MIN.
          MOV A,@R1                     ; READ TPLMT / BTLMT VALUE.
          DEC A                         ; DEC ACC.
          MOV @R1,A                     ; STORE DECREMENTED VALUE IN PLMT / BTLMT
DCRET:    RET                           ; RETURN.
                                        ;
BYSET:    MOV R0,#KEYPR                 ; ASSIGN R0 TO KEYPR.
          MOV A,@R0                     ; READ KEYPR.
          JB4 BYINC                     ; JUMP TO BYINC IF ACC BIT 4 IS SET.
          JB6 BYDEC                     ; JUMP TO BYDEC IF ACC BIT 6 IS SET.
          JMP BYRET                     ; KEY SERVED.
BYINC:    MOV A,@R1                     ; READ HICAL VALUE.
          XRL A,#0FFH                   ; COMPARE WITH MAX COUNT OF 0FFH.
          JZ BYRET                      ; IF ZERO HICAL WAS AT FF 255 MAX.
          INC @R1                       ; IF NOT THEN INCREMENT HICAL.
          JMP BYRET                     ; RETURN.
BYDEC:    MOV A,@R1                     ; READ HICAL VALUE.
          JZ BYRET                      ; IF ZERO HICAL WAS AT 0  MIN.
          DEC A                         ; DEC ACC.
          MOV @R1,A                     ; STORE DECREMENTED VALUE IN HICAL.
BYRET:    RET                           ; RETURN TO REACT TO RMPSRV
                                        ;
RMPST:    MOV R3,#0                     ; SET R3 TO 0 TO INDICATE KEYPRESS SERVICED.
          MOV R0,#TIMES                 ; SET R0 TO TIMES LOC.
          MOV R1,#RAMPS                 ; SET R1 TO RAMPS LOC.
          MOV A,@R1                     ; READ RAMPS LOCATION.
          DEC A                         ; DECREMENT A BY ONE TO MAKE KEY RTN FASTER.
          JZ SETON                      ; AS ONE IS MIN LT DO NO GO BEYOND 1.
          JMP SETIT                     ; IF NOT ZERO DECREMENT IS OK.
SETON:    MOV @R0,#1                    ; MAX SPEED OF RAMP.
          MOV @R1,#1                    ; MAX SPEED OF RAMP.
          JMP LNGSR                     ; SET LNG TIME AND RETURN
SETIT:    MOV @R0,A                     ; RAMP UP A LITTLE FASTER AS THE DEC VALUE RETURNS KEY.
          MOV @R1,A                     ; REPETED KEY PRESSES DEC THE 50(SLOWS) TO 1 FAST.
          JMP LNGSR                     ; SET LNG TIME AND RETURN
SERVT:    MOV R3,#0                     ; SET R3 TO 0 TO INDICATE KEYPRESS SERVICED.
          MOV R1,#RAMPS                 ; SET R1 TO RAMPS LOC.
          MOV @R1,#FASTS                ; SET MIN RAMP SPEED AS SOME OTHER FUNCTION SELECTED.
          MOV R0,#TIMES                 ; SET R0 TO TIMES LOC.
          MOV @R0,#SLOWS                ; 300MS TIME NO OTHER KEY PRESS WILL BE TAKEN.
LNGSR:    MOV R1,#LNGTM                 ; SET R1 TO LNGTM LOC. THIS IS TO BRING BACK TO NORMAL.
          MOV @R1,#LRATE                ; SET LONG TIMER TO 300MS*30 9SECONDS.
          RET                           ; RETURN
