CNTRL:    MOV R2,#SP1MP                 ; THREE UNALTERABLE LOCATIONS FOR SP/DB/OP AS PER MAP
          MOV R4,#SD1MP                 ; R0 AND R1 WILL BE POINTERS AND R7 THE DVMNO CHANGES.
          MOV R5,#OPSP1                 ; THESE WILL BE REFFERD AGAIN AND AGAIN DURING CNTRL.
          MOV R0,#TWOSP                 ; LOC 34 TWOSP IN R0 POINTER,TO COUNTDOWN EVERY SP DONE
          MOV @R0,#2                    ; AS 2 SP IS USED WRITE TWO IN 34 LOCATION.
          CLR F0                        ; AS F0 IS USED AS COMPLIMENT MARKER.
          MOV R0,#ALRM1                 ; SET R0 TO ALRM1 SET TO 1 IN LNGRT IF DB=0 SET 0 INOUT.
          MOV A,@R0                     ; READ STATUS,IF 0 JUMP OVER IF 1 ALLOW ONLY OFF OF OP.
          JZ LOOPX                      ; IF ZERO JUMP OVER TO LOOPX AS IT IS ON OFF.
          MOV R1,#OPSP1                 ; SET POINTER R1 TO READ OP STATUS.
          MOV R0,#DB1MP                 ; SET R0 TO DB1MP WHICH IS 0 NORMAL 1 FOR OUTPUT INV.
          MOV A,@R1                     ; READ OP STATUS TO ACC.
          JZ INVR1                      ; INVERT THE OUTPUT IF DB1MP POL SET TO 1 IE NEG.
          MOV A,#1                      ; IF NON ZERO CHANGE NZ VALUE(LED PATTN) TO 1.
INVR1:    XRL A,@R0                     ; INVERT THE OUTPUT IF DB1MP POL SET TO 1 IE NEG.
          JNZ LOOPX                     ; IF NOT ZERO DO NO ACT JUMP OVER.
          JMP CLBAK                     ; AS IT IS ZERO DO NOT CHANGE RELAY LATCH IT.
CLOOP:    MOV R0,#ALRM2                 ; SET R0 TO ALRM2 SET TO 1 IN LNGRT IF DB=0 SET 0 INOUT.
          MOV A,@R0                     ; READ STATUS,IF 0 JUMP OVER IF 1 ALLOW ONLY OFF OF OP.
          JZ LOOPX                      ; IF ZERO JUMP OVER TO LOOPX AS IT IS ON OFF.
          MOV R1,#OPSP2                 ; SET POINTER R1 TO READ OP STATUS.
          MOV R0,#DB2MP                 ; SET R0 TO DB1MP WHICH IS 0 NORMAL 1 FOR OUTPUT INV.
          MOV A,@R1                     ; READ OP STATUS TO ACC.
          JZ INVR2                      ; INVERT THE OUTPUT IF DB1MP POL SET TO 1 IE NEG.
          MOV A,#1                      ; IF NON ZERO CHANGE NZ VALUE(LED PATTN) TO 1.
INVR2:    XRL A,@R0                     ; INVERT THE OUTPUT IF DB1MP POL SET TO 1 IE NEG.
          JNZ LOOPX                     ; IF NOT ZERO DO NO ACT JUMP OVER.
          JMP CLBAK                     ; AS IT IS ZERO DO NOT CHANGE RELAY LATCH IT.
LOOPX:    MOV A,R5                      ; READ R5 MEMLOC OF OPSP1 ON OFF DATA TO ACC.
          MOV R0,A                      ; LOAD MEMLOC TO R0 POINTER.
          MOV A,@R0                     ; READ OUTPUT STATUS TO ACC.
          JZ SDSEL                      ; IF OUTPUT IS ZERO OFF JMP SDSEL
          CLR F0                        ; SET F0=0 TO SET IT 1 BELOW
          CPL F0                        ; F0 =1 IF SP WAS SELECTED OP COMPLIMENT BY SP.
          MOV A,R2                      ; MOVE SP MAP R2 POL POS TO A.
          JMP SPSEL                     ; SP#MP HAS BEEN SELECTED AS OP IS OFF.
SDSEL:    MOV A,R4                      ; READ ADDR OF SD1MP OR SD2MP LOC TO A.
SPSEL:    MOV R1,A                      ; LOAD SP#MP OR SD#MP LOC TO R1 AS PER OP STATUS.
          MOV R0,#PRVMP                 ; LOAD IT TO RAM POINTER R0.
          MOV A,@R0                     ; READ PV POLARITY.
          XRL A,@R1                     ; COMPARE WITH SP POL.
          JNZ OPRET                     ; IF NON ZERO DIFF POL SP AND PV THEN TURN ON OUTPUT.
CMPER:    MOV R7,#DVMNO                 ; MOV R7 TO 4 TO LOOP DJNZ FOR COMAPRING PV AND SP.
CPLOP:    INC R0                        ; GO TO THOUSANDS PLACE OF SP.
          INC R1                        ; K PLACE OF PV.
          MOV A,@R0                     ; READ K,H,T,U IN THAT ORDER OF SP INTO ACC AS IT LOOPS.
          XRL A,@R1                     ; COMPARE WITH CORRESPONDING PLACE IN PV.
          JNZ SUBTR                     ; IF MISMATCH DESISON TO OFF RELAY CAN BE TAKEN NOW.
          DJNZ R7,CPLOP                 ; IF ZERO BOTH HAD SAME VALUE HENCE NEXT DIGITLOOP.
          MOV A,R5                      ; VALUES ARE MATCHED HENCE COMPLIMENT OUTPUT.
          MOV R1,A                      ; GET CURRENT OUTPUT LOC R5(1ST LOOP OPSP1 2ND OPSP2)
          MOV A,@R1                     ; READ OP STATUS TO ACC.
          JZ OPRET                      ; LOAD IT TO POINTER R1.
          JMP OPRAT                     ; OPSP# IS COMPLIMENTED JUMP OVER.
SUBTR:    CLR C                         ; CARRY IS CLEARED AS ITS RESULT IS CRITICAL NOW.
          MOV A,@R0                     ; READ MISMATCHED PLACE OF PV TO ACC.
          CPL A                         ; PV-SP OF THAT DIGIT PERFORMED SUBSTRACION.
          ADD A,@R1                     ; X-Y, X TO ACC CPL A ADD Y TO ACC CPL A A = X-Y.
          JC OPRET                      ; IF CARRY IS SET THAT DIGIT OF SP > PV ON RELAY.
          JMP OPRAT                     ; IF CARRY NOT SET RELAY STATUS IS UNALTERED.
OPRET:    CLR C                         ; CLEAR CARRY AS IT OR POL BROUGHT IT HERE.
          MOV A,R5                      ; GET CURRENT OUTPUT LOC R5(1ST LOOP OPSP1 2ND OPSP2)
          MOV R1,A                      ; LOAD IT TO POINTER R1.
          JF0 SPINV                     ; IF F0=1 INVERT OP WITH SP POL.
          MOV A,R4                      ; IF F0=0 INVERT OP WITH SD POL.
          JMP SDINV                     ; JUMPOVER TO INV 1 WITH POL OF SDMP
SPINV:    MOV A,R2                      ; SET R0 TO SPMP POL.
SDINV:    MOV R0,A                      ; SET R0 TO SD#MP OR ST#MP AS SELECTED BY F0.
          MOV A,@R0                     ; READ TO ACC POL OF MAP.
          XRL A,#1                      ; COPLIMENT WITH ON RELAY=1
          MOV @R1,A                     ; STORE IN OPSP# LOCATION.
          JMP CLBAK                     ; RELAY HAS BEEN SET ON GO BACK.
OPRAT:    CLR C                         ; CLEAR CARRY AS IT OR POL BROUGHT IT HERE.
          MOV A,R5                      ; GET CURRENT OUTPUT LOC R5(1ST LOOP OPSP1 2ND OPSP2)
          MOV R1,A                      ; LOAD IT TO POINTER R1.
          JF0 SPCMP                     ; IF F0=1 INVERT OP WITH SP POL.
          MOV A,R4                      ; IF F0=0 INVERT OP WITH SD POL.
          JMP SDCMP                     ; JUMPOVER TO INV 1 WITH POL OF SDMP
SPCMP:    MOV A,R2                      ; SET R0 TO SPMP POL.
SDCMP:    MOV R0,A                      ; SET R0 TO SD#MP OR ST#MP AS SELECTED BY F0.
          MOV A,@R0                     ; READ TO ACC POL OF MAP.
          XRL A,#0                      ; COPLIMENT WITH ON RELAY=1
          MOV @R1,A                     ; STORE IN OPSP# LOCATION.
CLBAK:    CLR F0                        ; AS F0 IS USED AS COMPLIMENT MARKER.
          MOV R0,#TWOSP                 ; SET R0 TO TWOSP LOC IN RAM.
          MOV A,@R0                     ; READ IT 0,1,2
          DEC A                         ; DEC BY 1.
          JZ CLRET                      ; IF ZERO BOTH SETPOINTS OVER HENCE RETURN.
          MOV @R0,A                     ; WRITE BACK TO LOC.
          MOV R2,#SP2MP                 ; SET LOCATIONS RELATED TO 2ND SETPOINT.
          MOV R4,#SD2MP                 ; DB MAP LOC OF 2ND SP POLARITY POSITION.
          MOV R5,#OPSP2                 ; LOCATION OF O/P 1 IS ON 0 IS OFF.
          JMP CLOOP                     ; JUMP CLOOP ONE MORE TIME TO WORK ON SETPOINT 2.
CLRET:    CALL OUTP1                    ; CALL OUTPT PROGRAM TO SET RELAY1.
          CALL OUTP2                    ; CALL OUTPT PROGRAM TO SET RELAY2.
          RET                           ; RETURN TO MAIN ILLOP.
                                        ;
OUTP1:    MOV R0,#OPSP1                 ; LOC 105 OPSP1, SET TO R0.
          MOV R1,#DB1MP                 ; SET R1 TO DB1MP WHICH IS 0 NORMAL 1 FOR OUTPUT INV.
          MOV A,@R0                     ; READ OP STATUS TO ACC.
          XRL A,@R1                     ; INVERT THE OUTPUT IF O1INV SET TO 1.
          JNZ PROPR                     ; IF 1 SET AS PER LED CODE.
          JMP OFFLO                     ; IF ZERO OFF RELAY.
PROPR:    MOV @R0,#00100000B            ; 00000000B IF OFF 00100000B IF ON SET IN CNTRL.
          ANL P2,#01111111B             ; OTHER  P2 IS UNALTERED AS 1 AND HAS NO EFFECT ON DATA.
          JMP SPTOP                     ; JUMP TO SECOND SET POINT.
OFFLO:    MOV @R0,#0                    ; WRITE OPSP1 LOC WITH STATUS AFTER INVERTING IF APPL.
          ORL P2,#10000000B             ; OTHER  P2 IS UNALTERED AS 0 OR HAS NO EFFECT ON DATA.
SPTOP:    RET                           ; RETURN.
                                        ;
OUTP2:    MOV R0,#OPSP2                 ; LOC 106 OPSP2, SET TO R0.
          MOV R1,#DB2MP                 ; SET R1 TO DB2MP WHICH IS 0 NORMAL 1 FOR OUTPUT INV.
          MOV A,@R0                     ; READ OP STATUS TO ACC.
          XRL A,@R1                     ; INVERT THE OUTPUT IF O2INV SET TO 1.
          JNZ PROPS                     ; IF 1 SET AS PER LED CODE.
          JMP OFFLP                     ; IF ZERO OFF RELAY.
PROPS:    MOV @R0,#01000000B            ; 00000000B IF OFF 01000000B IF ON SET IN CNTRL.
          ANL P2,#10111111B             ; OTHER  P2 IS UNALTERED AS 1 AND HAS NO EFFECT ON DATA.
          JMP OUTRT                     ; AS RELAY 2 IS SET JUMP OVER.
OFFLP:    MOV @R0,#0                    ; WRITE OPSP2 LOC WITH STATUS AFTER INVERTING IF APPL.
          ORL P2,#01000000B             ; OTHER  P2 IS UNALTERED AS 0 OR HAS NO EFFECT ON DATA.
OUTRT:    RET                           ; RETURN WHERE CALLED.
                                        ;
DNSET:    MOV R0,#KEYPR                 ; ASSIGN R0 TO KEYPR.
          MOV A,@R0                     ; READ KEYPR.
          JB4 INCDP                     ; JUMP TO INCDP IF ACC BIT 4 IS SET.
          JB6 DECDP                     ; JUMP TO DECDP IF ACC BIT 6 IS SET.
          JMP DPRET                     ; RETURN.
INCDP:    MOV A,@R1                     ; READ DPSET VALUE.
          XRL A,#10                     ; COMPARE WITH MAX COUNT OF 10.
          JZ DPRET                      ; IF ZERO HICAL WAS AT 10 MAX.
          INC @R1                       ; IF NOT THEN INCREMENT DPSET.
          JMP DPRET                     ; RETURN.
DECDP:    MOV A,@R1                     ; READ DPSET VALUE.
          JZ DP5ST                      ; IF ZERO DONT DECREMENT
          XRL A,#5                      ; COMPARE WITH MIN COUNT OF 5.
          JZ DPRET                      ; IF ZERODPRET WAS AT 5  MIN.
          MOV A,@R1                     ; READ DPSET VALUE.
          DEC A                         ; DEC ACC.
          MOV @R1,A                     ; STORE DECREMENTED VALUE IN DPSET.
          JMP DPRET                     ; RETURN.
DP5ST:    MOV @R1,#5                    ; SET MIN DECREMENTED VALUE.
DPRET:    RET                           ; RETURN TO REACT TO RMPSRV
                                        ;
DISEL:    MOV R0,#DISPL                 ; LOC 104 DISPL HOLDS DISPLAY SELECT LOC 0 FOR PV
          MOV A,@R0                     ; READ DISPL.
          INC A                         ; PV,SP1,DB1,SP2,DB2. BCD 0,1,2,3,4
          XRL A,#MAXDS                  ; IN CASE OF 5 REQ AS ABOVE MAXDS EQU 5
          JZ LIMIT                      ; IF ZERO MAX DISPLAY COUNT REACHED.
          JMP WITIN                     ; IF NOT LESS THAN 5.
LIMIT:    MOV @R0,#0                    ; SET DISPL TO 0 TO SCROLL BACK AFTER 4.
          JMP DISRT                     ; KEY SERVED.
WITIN:    INC @R0                       ; INCREMENT DISPL BY 1.
DISRT:    RET                           ; RETURN TO REACT.
