AD256:    CALL SETRX                    ; ADD 256 TO CNTMP EVERY TIME THIS IS CALLED.
          MOV R1,#B0256                 ; SET R1 TO ADDR OF PROM.
          CALL HEXCD                    ; SETS BCD NO ADDR IN ACC TO ADDMP.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
          RET                           ; END OF SUBROT.
                                        ;
HEXCD:    MOV R7,#DVMNO                 ; SET R7 TO 4 .
          MOV A,R4                      ; READ ADDMP POL LOCATION NON-EXISTANT.
          MOV R0,A                      ; SET R0 POINTER TO ADDMP.
LUPHX:    INC R0                        ; GO TO NEXT PLACE OF ADDMP K, H, T, U.
          MOV A,R1                      ; READ ADDR OF 0256 LOC.
          MOVP3 A,@A                    ; GET FROM PROG MEM TO ACC @ BY ACC. GET CODE.
          MOV @R0,A                     ; WRITE K VALUE OF CONSTANT IN K OF ADDMP.
          INC R1                        ; GET ADDR OF NEXT CONSTANT H, T, U.
          DJNZ R7,LUPHX                 ; LOOP TO LUPHS TO UPDATE ADDMP WITH NUMBER HEX.
          RET                           ; END OF SUBROT.
                                        ;
ADBYT:    MOV A,T                       ; ADD COUNTS IN BINARY IN T TO CNTMP.
          JB7 CNT01                     ; READ RESIDUAL COUNTS TO ACC,IF BIT 7 SET 128 ADD.
          JMP CNT02                     ; IF NOT JUMP OVER TO CHECK OTHER BITS.
CNT01:    CALL SETRX                    ; SET R2,R4,R5, REGISTERS.
          MOV R1,#B0256 + {DVMNO*1}     ; SET R1 $ OF B0256+4 WHICH GIVES K PLACE OF 128.
          CALL HEXCD                    ; SETS BCD NO ADDR IN ACC TO ADDMP.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
CNT02:    MOV A,T                       ; READ COUNTER AGAIN.
          JB6 CNT03                     ; IF BIT 6 IS SET VALUE IS 64 HENCE ADD 64.
          JMP CNT04                     ; IF NOT JUMP NEXT BIT.
CNT03:    CALL SETRX                    ; SET R2,R4,R5, REGISTERS.
          MOV R1,#B0256 + {DVMNO*2}     ; SET R1 $ OF B0256+8 WHICH GIVES K PLACE OF 064.
          CALL HEXCD                    ; SETS BCD NO ADDR IN ACC TO ADDMP.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
CNT04:    MOV A,T                       ; READ COUNTER AGAIN.
          JB5 CNT05                     ; IF BIT 5 IS SET VALUE IS 32 HENCE ADD 32.
          JMP CNT06                     ; IF NOT JUMP NEXT BIT.
CNT05:    CALL SETRX                    ; SET R2,R4,R5, REGISTERS.
          MOV R1,#B0256 + {DVMNO*3}     ; SET R1 $ OF B0256+12 WHICH GIVES K PLACE OF 032.
          CALL HEXCD                    ; SETS BCD NO ADDR IN ACC TO ADDMP.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
CNT06:    MOV A,T                       ; READ COUNTER AGAIN.
          JB4 CNT07                     ; IF BIT 4 IS SET VALUE IS 16 HENCE ADD 16.
          JMP CNT08                     ; IF NOT JUMP NEXT BIT.
CNT07:    CALL SETRX                    ; SET R2,R4,R5, REGISTERS.
          MOV R1,#B0256 + {DVMNO*4}     ; SET R1 $ OF B0256+12 WHICH GIVES K PLACE OF 016.
          CALL HEXCD                    ; SETS BCD NO ADDR IN ACC TO ADDMP.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
CNT08:    MOV A,T                       ; AS ONLY LOWER NIBBLE IN ACC TO BE COUNTED .
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE.
          ADD A,#0                      ; ADD 0 TO ACC TO SET CARRY=0 AND AUX CARRY AS REQ.
          DA A                          ; DECIMAL ADJUST ACC.
          MOV R1,A                      ; STORE FINAL ADD IN R1.
          CALL SETRX                    ; SET R2,R4,R5, REGISTERS.
          MOV A,R4                      ; READ ADDMP POL LOCATION NON-EXISTANT.
          MOV R0,A                      ; SET R0 POINTER TO ADDMP POL LOCATION NON EXIS.
          INC R0                        ; SET R0 POINTER TO ADDMP KILOS LOCATION.
          MOV @R0,#0                    ; SET KILOS LOCATION TO 0.
          INC R0                        ; SET R0 POINTER TO ADDMP HUNDS LOCATION.
          MOV @R0,#0                    ; SET HUNDS LOCATION TO 0.
          INC R0                        ; SET R0 POINTER TO ADDMP TENS LOCATION.
          MOV A,R1                      ; READ STORED LAST DECIMAL COUNTS IN ACC.
          SWAP A                        ; SWAP UPPER AND LOWER NIBBLES.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE UNITS AFTER SWAP.
          MOV @R0,A                     ; WRITE TENS VALUE OF SWAPPED UPPER NIBBLE IN ACC.
          INC R0                        ; SET R0 POINTER TO ADDMP UNITS LOCATION.
          MOV A,R1                      ; READ STORED LAST DECIMAL COUNTS IN ACC.
          ANL A,#SEGCD                  ; 0FH AND TO LOSE UPPER NIBBLE TENS.
          MOV @R0,A                     ; WRITE UNITS VALUE OF INTO ADDMP UNITS PLACE.
          CALL BCDPM                    ; CALL ROUTINE BCD PLUS MINUS.
          RET                           ; END OF SUBROT.
                                        ;
SETRX:    MOV R2,#CNTMP                 ; THIS IS THE BASE NUMBER TO WHICH R4MP IS ADDED.
          MOV R4,#ADDMP                 ; THIS IS A BUFFER MAP HOLDING THE NUMBER TO ADD.
          MOV R5,#CNTMP                 ; THE RESULT OF BCD ADD OR SUBSTRACT WILL BE IN THIS.
          RET                           ;
                                        ;
REDSP:    CLR F1                        ; CLEAR FLAG 1.
          MOV R1,#GATER                 ; SET R1 TO TICKS*GATER IS GATING PERIOD
          MOV @R1,#HICUL                ; RESET GATER LOCATION AS 3 MAX REACHED.
          MOV R1,#TICKS                 ; MOVE 103 ADDR FOR DELAY INTO R1.
          MOV @R1,#HICAL                ; RESET TIMER BY RELOADING 250 SAMPLE RATE.
          CLR A                         ; SET ACC TO 0 TO RESET COUNTER.
          MOV T,A                       ; MOVE ACC CONTENTS TO COUNTER LOAD.
          MOV R1,#FLAG2                 ; SET R1 TO FLAG2 WHICH IS 1 IF START CNT HAS TO BE DONE.
          MOV @R1,#1                    ; START COUNT IN EXINT FILTER.
          MOV R7,#DVMNO+1               ; SET R7 TO 5 .
          MOV R1,#PRVMP                 ; MOVE TO R1 40-4=36 LOC.
          MOV R0,#CNTMP                 ; MOVE TO R0 97-4=93 LOC.
          CALL FILIT                    ; CALL FILLIT ROUTINE TO FILL PRVMP WITH CNTMP.
          MOV R7,#DVMNO+1               ; SET R7 TO 5 . THIS SETS THE ZERO OFFSET OF THE CNTMP.
          MOV R1,#CNTMP                 ; MOVE TO R1 97-4=93 LOC.
          MOV R0,#ZERMP                 ; MOVE TO R0 85-4=81 LOC.
          CALL FILIT                    ; CALL FILLIT ROUTINE TO FILL PRVMP WITH CNTMP.
          RET                           ; RETURN TO WHERE LEFT.
                                        ;
FILIT:    MOV A,@R0                     ; READ RAM LOC THE POL PLACE OF 1STMP.
          MOV @R1,A                     ; WRITE DATA AT POL LOC OF 2ND MAP.
          INC R1                        ; CHANGE ADDR R1 TO K,H,T,U AS DJNZ LOOPS.
          INC R0                        ; CHANGE ADDR R0 TO K,H,T,U AS DJNZ LOOPS.
          DJNZ R7,FILIT                 ; LOOP TO FILIT TILL R7=0.
          RET                           ; RETURN TO WHERE LEFT.
                                        ;
KBDIN:    MOV @R0,#SRATE                ; AFTER 30MS. ASSUMING 5 DISPLAYS 6MS*5SRATE=30
          MOV R0,#TEMKY                 ; R0 SET TO 112 LOC OF TEMP KEY PRESS.
          MOV A,@R0                     ; READ TEMPKY KEYPRESS AT 112.
          MOV R1,#KEYRT                 ; SET R0 TO LOCATION 108
          JZ INVAL                      ; IF 0 NO KEY WAS PRESSED HENCE RETURN.
          MOV A,@R1                     ; READ KEYRT.
          XRL A,#BOUNC                  ; XOR 5 WITH KEYRT IF FIRST TIME 5 XOR 5 =0
          JZ PRIME                      ; IT IS THE FIRST HENCE JUMP TO LOG FIRST KEY PRESS.
          JMP CHECK                     ; IT IS 2ND OR LATER UPTO FIVE VERIFY IF SAME.
PRIME:    MOV A,@R0                     ; READ TEMKY VALUE.
          MOV R0,#KEYPR                 ; SET R0 TO LOCATION 109
          MOV @R0,A                     ; PUT TEMKY VALUE IN KEYPR.
          JMP OKPRS                     ; RETURN AS 1ST KEY PRESS RECORDED.
CHECK:    MOV A,@R0                     ; READ TEMKY VALUE.
          MOV R0,#KEYPR                 ; SET R0 TO LOCATION 109
          XRL A,@R0                     ; COMPARE TEMKY AND LAST KEYPR.
          JZ OKPRS                      ; IF 0 OKPRS.
          JMP INVAL                     ; IF NOT ZERO INVALID.
OKPRS:    MOV A,@R1                     ; RED KEYRT .
          DEC A                         ; DEC.
          MOV @R1,A                     ; WRITE INTO KEYRT.
          JZ VALID                      ; IF ZERO 5 TIME VERIFIED HENCE VALID.
          JMP KBEND                     ; IF NOT 5 TIMES NO YET DONE.
VALID:    MOV R3,#1                     ; SET R3 TO 1 TO INDICATE VALID KEYPR AT 109.
INVAL:    MOV @R1,#BOUNC                ; RELOAD 5 INTO KEYRT LOCATION.
KBEND:    RET                           ; RETURN TO ILOOP WITH KEYPRESS IF ANY.
                                        ;
ARNGE:    MOV R0,#LNGTM                 ; CALLED EVERY 200MS TO UPDATE DISPLAY AS PER KEY REQ.
          MOV A,@R0                     ; READ LOCATION.
          DEC A                         ; COUNTDOWN TIMER EVERY 300MS.
          MOV @R0,A                     ; WRITE BACK.
          JZ LNORM                      ; IF TIME 0 TIME OUT JMP LNORM TO SET ALL TO NRM MDS.
          JMP AGRET                     ; IF NOT END AT AGRET
LNORM:    MOV R1,#PRGRN                 ; SET TO RUNMODE 0.
          MOV @R1,#0                    ; PROG MODE TURNED OFF AFTER 10 SECONDS IF NO KEY PRSS.
          MOV R1,#CALRN                 ; SET CALRN 0 AS CALIBRATION IS OVER.
          MOV @R1,#0                    ; CAL MODE TURNED OFF AFTER 10 SECONDS IF NO KEY PRSS.
          MOV R1,#DISPL                 ; SET DISPL TO 0.
          MOV @R1,#0                    ; DISPL SET TO 0 PV SO AFTER ANY SELECTION AUTO PV 10S.
          MOV @R0,#LRATE                ; PRESET LONG TIMER.
          CALL LNGRT                    ; LVL 1 NEST CALL LNGRT EVERY 10 SECS.
AGRET:    RET                           ; ARNGE RETURNS TO ILOOP.
